;-----------------------------------------------------------------------
; DateiName        :  keyinout.asm
;-----------------------------------------------------------------------
; Author           :  Christian Rsch
;
; Erstellungsdatum :  01.11.2001
;-----------------------------------------------------------------------
; Info : Liest eine Tasten von der Tastatur, bei ESC wird das Programm
;        beendet. Bei einer Zahlentaste wird die Zahl ausgegeben und
;        beendet.
;-----------------------------------------------------------------------


; Dies ist das Daten-Segment

data SEGMENT
assume DS:data
press    db "press any numeric key! (ESC 2 quit)",13,10,"$"
data ends



; Dies ist das Stack-Segment

stackdata SEGMENT stack
assume SS:stackdata
        db 256 dup(?)           ; definiert die Grsse des Stacks
stackdata ends



; Dies ist das Code-Segment

code SEGMENT
ASSUME CS:code

start:                          ; hier beginnt die Abarbeitung des Programmshier beginnt die
        mov     ax, data        ; Adresse des Daten Segments nach ax
        mov     ds, ax          ; DatenSegment nach ds

        mov     dx,OFFSET press ; Offset des Textes nach dx
        mov     ax,0900h        ; Funktion 0900h (String ausgeben)
        int     21h             ; Interrupt auslsen

wait4keys:
        mov     ah,01h          ; Tastaturbuffer checken
        int     16h
        jz      wait4keys       ; warten bis Taste gedrckt
        mov     ah,00h          ; Tastaturbuffer lesen
        int     16h

        cmp     al,27
        je      ende            ; bei ESC beenden

        cmp     al,'0'          ; kleiner '0' ?
        jb      wait4keys       ; dann zurck
        cmp     al,'9'          ; grsser '9' ?
        ja      wait4keys       ; dann zurck

        mov     ah,0ah          ; Zeichen ausgeben
        mov     bh,0            ; Seite 0
        mov     cx,1            ; einmal reicht
        int     10h

ende:
        mov     ax, 4c00h       ; Funktion 4c00h (Programmende)
        int     21h             ; Interuppt auslsen


code ENDS



     end     start              ; Start als Einsprungpunkt definieren

;-----
; EOF
;-----
